ALTER TABLE F_FLIGHTS DROP CONSTRAINT FK_TAILNUM2PLANE_DATA;
ALTER TABLE F_FLIGHTS DROP CONSTRAINT FK_ORIGIN_ID_AIRPORT;
ALTER TABLE F_FLIGHTS DROP CONSTRAINT FK_DEST_ID_AIRPORT;
ALTER TABLE F_FLIGHTS DROP CONSTRAINT FK_DEP_DATE_ID_CAL;
ALTER TABLE F_FLIGHTS DROP CONSTRAINT FK_CRSDEP_DATE_ID_CAL;
ALTER TABLE F_FLIGHTS DROP CONSTRAINT FK_ARR_DATE_ID_CAL;
ALTER TABLE F_FLIGHTS DROP CONSTRAINT FK_CRSDEP_DATE_ID_CAL;
ALTER TABLE D_AIRPORT2STATIONS DROP CONSTRAINT FK_AIRPORT_ID_AIRPORT2STATIONS;
ALTER TABLE D_AIRPORT2STATIONS DROP CONSTRAINT FK_STATION_ID_STATE2STATIONS;
ALTER TABLE D_STATIONS DROP CONSTRAINT FK_STATES_ID_STATES;
ALTER TABLE F_WEATHER DROP CONSTRAINT FK_STATION_ID_STATIONS;
ALTER TABLE F_WEATHER DROP CONSTRAINT FK_OBS_TIME_CAL;

ALTER TABLE D_AIRPORT DROP CONSTRAINT DWH_ID_D_AIRPORT_unique;
ALTER TABLE D_PLANE_DATA DROP CONSTRAINT DWH_ID_D_PLANE_DATA_UNIQUE;
ALTER TABLE D_STATIONS DROP CONSTRAINT DWH_ID_D_AIRPORT_unique;
ALTER TABLE D_STATES DROP CONSTRAINT DWH_ID_D_AIRPORT_unique;
ALTER TABLE F_FLIGHTS DROP CONSTRAINT DWH_ID_D_AIRPORT_unique;
ALTER TABLE F_WEATHER DROP CONSTRAINT DWH_ID_D_AIRPORT_unique;

TRUNCATE TABLE D_AIRPORT; 
TRUNCATE TABLE D_PLANE_DATA;  
TRUNCATE TABLE D_STATIONS;
TRUNCATE TABLE F_FLIGHTS; 
TRUNCATE TABLE F_WEATHER;
TRUNCATE TABLE D_AIRPORT2STATIONS;

DROP TABLE D_AIRPORT; 
DROP TABLE D_PLANE_DATA;  
DROP TABLE D_STATIONS;
DROP TABLE F_FLIGHTS; 
DROP TABLE F_WEATHER;
DROP TABLE D_AIRPORT2STATIONS;

ALTER TABLE D_AIRPORT NOLOGGING;
ALTER TABLE D_PLANE_DATA NOLOGGING;
ALTER TABLE D_STATIONS NOLOGGING;
ALTER TABLE F_FLIGHTS NOLOGGING;
ALTER TABLE F_WEATHER NOLOGGING;
ALTER TABLE D_AIRPORT2STATIONS NOLOGGING;



CREATE TABLE D_AIRPORT 
(	
DWH_ID NUMBER,
DWH_SOURCE_KEY varchar(50),
DWH_DELETE_FLAG varchar2(1),
DWH_VALID_FROM date,
IATA varchar2(4), 
AIRPORT varchar2(41), 
CITY varchar2(33), 
STATE_CODE varchar2(2),
STATE_NAME varchar2(50),
COUNTRY varchar2(30), 
LAT varchar2(30), 
LONGS varchar2(30)
);

CREATE TABLE D_PLANE_DATA 
(	
DWH_ID NUMBER,
DWH_SOURCE_KEY varchar(50),
DWH_DELETE_FLAG varchar2(1),
DWH_VALID_FROM date,
FK_ISSUE_DATE NUMBER,
MANUFACTURE_YEAR date,
ENGINE_TYPE varchar2(20),
AIRCRAFT_TYPE varchar2(30), 
STATUS varchar2(20), 
MODEL varchar2(20),
ISSUE_DATE date,
MANUFACTURER varchar2(30), 
"TYPE" varchar2(20),  
TAILNUM varchar2(20)
);

CREATE TABLE D_STATIONS 
(	
DWH_ID number,
DWH_SOURCE_KEY varchar(50),
DWH_DELETE_FLAG varchar2(1),
DWH_VALID_FROM date,
"ID" varchar2(11), 
LATITUDE varchar2(15), 
LONGITUDE varchar2(15), 
ELEVATION varchar2(15), 
STATE_CODE varchar2(2),
STATE_NAME varchar2(50), 
"NAME" varchar2(30), 
GSNFLAG varchar2(3), 
HCNFLAG varchar2(3), 
WMOID varchar2(5)
) ; 

drop table f_flights;
CREATE TABLE F_FLIGHTS 
(	
DWH_ID number
,DWH_SOURCE_KEY VARCHAR2(50)
,DWH_DELETE_FLAG VARCHAR2(1)
,DWH_VALID_FROM DATE
,FK_DEST_ID NUMBER
,FK_ORIGIN_ID NUMBER
,FK_TAILNUM_ID NUMBER
,FK_DEP_DATE_ID NUMBER
,FK_CRSDEP_DATE_ID NUMBER
,FK_ARR_DATE_ID NUMBER
,FK_CRSARR_DATE_ID NUMBER
,DEPDATETIME date
,CRSDEPDATETIME date
,ARRDATETIME date
,CRSARRDATETIME date
,UNIQUECARRIER varchar2(20)
,FLIGHTNUM varchar2(20)
,TAILNUM varchar2(20)
,ACTUALELAPSEDTIME varchar2(20)
,CRSELAPSEDTIME varchar2(20)
,AIRTIME varchar2(20)
,ARRDELAY varchar2(20)
,DEPDELAY varchar2(20)
,ORIGIN varchar2(20)
,DEST varchar2(20)
,DISTANCE varchar2(20)
,TAXIIN varchar2(20)
,TAXIOUT varchar2(20)
,CANCELLED varchar2(20)
,CANCELLATIONCODE varchar2(20)
,DIVERTED varchar2(20)
,CARRIERDELAY varchar2(20)
,WEATHERDELAY varchar2(20)
,NASDELAY varchar2(20)
,SECURITYDELAY varchar2(20)
,LATEAIRCRAFTDELAY varchar2(20)
); 

CREATE TABLE F_WEATHER 
(	
DWH_ID number
,DWH_SOURCE_KEY VARCHAR2(50)
,DWH_DELETE_FLAG VARCHAR2(1)
,DWH_VALID_FROM DATE
,FK_STATION_ID NUMBER
,FK_OBS_TIME NUMBER
,STATION_ID VARCHAR2(50)
,WDATE VARCHAR2(50)
,WELEMENT VARCHAR2(50) 
,DATA_VALUE VARCHAR2(50)
,M_FLAG VARCHAR2(1)
,Q_FLAG VARCHAR2(1)
,S_FLAG VARCHAR2(1)
,OBS_TIME VARCHAR2(50)
,WYEAR NUMBER
);   

CREATE TABLE D_AIRPORT2STATIONS 
(	
DWH_ID NUMBER
,DWH_SOURCE_KEY VARCHAR2(50)
,DWH_DELETE_FLAG varchar2(1)
,DWH_VALID_FROM DATE
,FK_STATION_ID NUMBER 
,FK_AIRPORT_ID NUMBER
,DISTANCE NUMBER
);


ALTER TABLE D_AIRPORT ADD CONSTRAINT DWH_ID_D_AIRPORT_unique UNIQUE (DWH_ID);
ALTER TABLE D_PLANE_DATA ADD CONSTRAINT DWH_ID_D_PLANE_DATA_unique UNIQUE (DWH_ID);
ALTER TABLE D_STATIONS ADD CONSTRAINT DWH_ID_D_STATIONS_unique UNIQUE (DWH_ID);
ALTER TABLE F_FLIGHTS ADD CONSTRAINT DWH_ID_F_FLIGHTS_unique UNIQUE (DWH_ID);
ALTER TABLE F_WEATHER ADD CONSTRAINT DWH_ID_F_WEATHER_unique UNIQUE (DWH_ID);
ALTER TABLE D_AIRPORT2STATIONS ADD CONSTRAINT DWH_ID_D_AIRPORT2STATIONS_unique UNIQUE (DWH_ID);

ALTER TABLE F_FLIGHTS ADD CONSTRAINT FK_TAILNUM2PLANE_DATA FOREIGN KEY (FK_TAILNUM_ID) REFERENCES D_PLANE_DATA(DWH_ID);
ALTER TABLE F_FLIGHTS ADD CONSTRAINT FK_ORIGIN_ID_AIRPORT FOREIGN KEY (FK_ORIGIN_ID) REFERENCES D_AIRPORT(DWH_ID);
ALTER TABLE F_FLIGHTS ADD CONSTRAINT FK_DEST_ID_AIRPORT FOREIGN KEY (FK_DEST_ID) REFERENCES D_AIRPORT(DWH_ID);
ALTER TABLE F_FLIGHTS ADD CONSTRAINT FK_DEP_DATE_ID_CAL FOREIGN KEY (FK_DEP_DATE_ID) REFERENCES D_CALENDAR(DATE_KEY);
ALTER TABLE F_FLIGHTS ADD CONSTRAINT FK_CRSDEP_DATE_ID_CAL FOREIGN KEY (FK_CRSDEP_DATE_ID) REFERENCES D_CALENDAR(DATE_KEY);
ALTER TABLE F_FLIGHTS ADD CONSTRAINT FK_ARR_DATE_ID_CAL FOREIGN KEY (FK_ARR_DATE_ID) REFERENCES D_CALENDAR(DATE_KEY);
ALTER TABLE F_FLIGHTS ADD CONSTRAINT FK_CRSARR_DATE_CAL FOREIGN KEY (FK_CRSARR_DATE_ID) REFERENCES D_CALENDAR(DATE_KEY);
ALTER TABLE D_AIRPORT2STATIONS ADD CONSTRAINT FK_AIRPORT_ID_AIRPORT2STATIONS FOREIGN KEY (FK_AIRPORT_ID) REFERENCES D_AIRPORT(DWH_ID);
ALTER TABLE D_AIRPORT2STATIONS ADD CONSTRAINT FK_STATION_ID_STATE2STATIONS FOREIGN KEY (FK_STATION_ID) REFERENCES D_STATIONS(DWH_ID);
ALTER TABLE F_WEATHER ADD CONSTRAINT FK_STATION_ID_STATIONS FOREIGN KEY (FK_STATION_ID) REFERENCES D_STATIONS(DWH_ID);
ALTER TABLE F_WEATHER ADD CONSTRAINT FK_OBS_TIME_CAL FOREIGN KEY (FK_OBS_TIME) REFERENCES D_CALENDAR(DATE_KEY);



CREATE INDEX "F_FLIGHTS_SKEY_IDX" ON F_FLIGHTS ("DWH_SOURCE_KEY");
CREATE INDEX "F_WEATHER_SKEY_IDX" ON F_WEATHER ("DWH_SOURCE_KEY");
CREATE BITMAP INDEX "D_STATIONS_BITMAP_IDX" ON D_STATIONS ("STATE_CODE"); 
CREATE BITMAP INDEX "D_AIRPORT_BITMAP_IDX" ON D_AIRPORT ("STATE_CODE");
CREATE INDEX "D_AIRPORT_SKEY_IDX" ON D_AIRPORT ("DWH_SOURCE_KEY");
CREATE INDEX "D_PLANE_DATA_SKEY_IDX" ON D_PLANE_DATA ("DWH_SOURCE_KEY");
CREATE INDEX "D_STATIONS_SKEY_IDX" ON D_STATIONS ("DWH_SOURCE_KEY");
CREATE INDEX "D_AIRPORT2STATIONS_SKEY_IDX" ON D_AIRPORT2STATIONS ("DWH_SOURCE_KEY");


ALTER INDEX F_WEATHER_SKEY_IDX REBUILD;

